
void setSum(int i,int j,int k,int maxSumLog = 64){
    for(int iter = 0; iter < maxSumLog; ++iter){
        setValue(i, j);
        setAnd(j, j, k);
        shiftLeft(j, 1);
        setXor(k, i, k);
    }
    setValue(i, k);
    setOr(i, i, j);
}

void trySort(int i, int j){
    setValue(10, i);
    setValue(11, j);
    
    setXor(12, 10, 11);
    setAnd(10, 10, 12);
    setAnd(11, 11, 12);
    
    for(int i = 0; i < 6; ++i){
        setValue(12, 10);
        setValue(13, 11);
        shiftRight(12, 1 << i);
        shiftRight(13, 1 << i);
        setOr(10, 10, 12);
        setOr(11, 11, 13);
    }
    
    setXor(12, 10, 11);
    setAnd(10, 10, 12);
    setAnd(11, 11, 12);
    
    for(int i = 0; i < 6; ++i){
        setValue(12, 10);
        setValue(13, 11);
        shiftLeft(12, 1 << i);
        shiftLeft(13, 1 << i);
        setOr(10, 10, 12);
        setOr(11, 11, 13);
    }
    for(int i = 0; i < 6; ++i){
        setValue(12, 10);
        setValue(13, 11);
        shiftRight(12, 1 << i);
        shiftRight(13, 1 << i);
        setOr(10, 10, 12);
        setOr(11, 11, 13);
    }
    
    setAnd(12, i, 10);
    setAnd(13, j, 11);
    setOr(15, 12, 13);
    
    setNot(10, 10);
    setNot(11, 11);
    
    setAnd(12, i, 10);
    setAnd(13, j, 11);
    setOr(14, 12, 13);
    
    setValue(i, 14);
    setValue(j, 15);
}

void solve(int group){
    switch(group){
        case 1:{
            setNot(2, 1);
            shiftLeft(2, 63);
            shiftRight(2, 63);
        }
            break;
        case 2:{
            for(int iter = 0; iter < 64; ++iter){
                setValue(3, 1);
                setAnd(1, 1, 2);
                shiftLeft(1, 1);
                setXor(2, 2, 3);
            }
            setValue(3, 2);
        }
            break;
        case 3:{
            int sumPosition = 2;
            setValue(sumPosition, 1);
            shiftLeft(sumPosition, 63);
            shiftRight(sumPosition, 63);
            int sumLog = 0;
            for(int i = 1; i < 64; ++i){
                if(i & 1){
                    setValue(sumPosition + 1, 1);
                    shiftLeft(sumPosition + 1, 63 - i);
                    shiftRight(sumPosition + 1, 63);
                    
                    if((1ull<<(sumLog+1)) - 1 < i + 1)sumLog++;
                    setSum(sumPosition + 2, sumPosition, sumPosition + 1, sumLog);
                    sumPosition += 2;
                }else{
                    setValue(sumPosition - 1, 1);
                    shiftLeft(sumPosition - 1, 63 - i);
                    shiftRight(sumPosition - 1, 63);
                    
                    if((1ull<<(sumLog+1)) - 1 < i + 1)sumLog++;
                    setSum(sumPosition - 2, sumPosition, sumPosition - 1, sumLog);
                    sumPosition -= 2;
                }
            }
            if(sumPosition != 2)
                setValue(2, sumPosition);
        }
            break;
        case 4:{
            setXor(3, 1, 2);
            setAnd(1, 1, 3);
            setAnd(2, 2, 3);
            
            for(int i = 0; i < 6; ++i){
                setValue(3, 1);
                setValue(4, 2);
                shiftRight(3, 1 << i);
                shiftRight(4, 1 << i);
                setOr(1, 1, 3);
                setOr(2, 2, 4);
            }
            
            setXor(3, 1, 2);
            setAnd(1, 1, 3);
            setAnd(2, 2, 3);
            
            for(int i = 0; i < 6; ++i){
                setValue(3, 1);
                setValue(4, 2);
                shiftLeft(3, 1 << i);
                shiftLeft(4, 1 << i);
                setOr(1, 1, 3);
                setOr(2, 2, 4);
            }
            
            shiftRight(1, 63);
            shiftRight(2, 63);
        }
            break;
        case 5:{
            for(int i = 0; i < 64; ++i){
                setValue(2, 1);
                
                if(63 - i > 0)
                    shiftRight(2, 63 - i);
                
                shiftLeft(2, 63);
                
                if(63 - i > 0)
                    shiftRight(2, 63 - i);
                
                if(i > 0)setValue(4, 5);
                if(i > 0)shiftLeft(4, 1);
                for(int j = i; j>= 1; --j){
                    setAnd(3, 2, 4);
                    setOr(5, 3, 5);
                    shiftRight(2, 1);
                }
                setOr(5, 2, 5);
            }
            setValue(1, 5);
        }
            break;
        case 6:{
            for(int i = 1; i < 9; ++i){
                for(int j = 1; j < 9 - i + 1; ++j){
                    trySort(j, j + 1);
                }
            }
        }
            break;
    }
}
