const int N = 1e6+1;

long long sum[N], h;
stack<int> q;
int p[N], sz[N], c[N];
int tin[N], cl, e;
struct road
{
    int f, s, i;
    long long w;
} edge[N], edge1[N], lastEdge[N];
vector<road> ed[N];

int firstPosition[N];
void srt(int n){
    for(int i = 1; i <= n; ++i)
    {
        firstPosition[edge1[i].w]++;
    }
    int cnt = 0;
    for(int i = 0; i < N; ++i)
    {
        cnt += firstPosition[i];
        firstPosition[i] = cnt - firstPosition[i];
    }
    for(int i = 1; i <= n; ++i)
        edge[++firstPosition[edge1[i].w]] = edge1[i];
}

int get(int x)
{
    if (x == p[x])
        return x;
    return p[x] = get(p[x]);
}

inline void unite(int x,int y)
{
    x = get(x); y = get(y);
    if(sz[x] > sz[y]){
        sum[x] += sum[y];
        sz[x] += sz[y];
        p[y] = x;
    }else{
        sum[y] += sum[x];
        sz[y] += sz[x];
        p[x] = y;
    }
}

void dfs(int p, int prev)
{
    tin[p] = ++cl;
    for(road a : ed[p])
    {
        if(a.s != prev)
        {
            lastEdge[a.s] = a;
            dfs(a.s, p);
            int t = get(a.s);
            if (sum[t] + sum[get(p)] >= a.w){
                unite(t, get(p));
                sum[get(p)] -= a.w;
                
                add(a.i);
            }else{
                q.push(a.s);
            }
        }
    }
    while(!q.empty() && tin[p] <= tin[q.top()])
    {
        int t = get(q.top());
        if(sum[get(p)] + sum[t] >= lastEdge[q.top()].w){
            unite(t, get(p));
            sum[get(p)] -= lastEdge[q.top()].w;
            
            add(lastEdge[q.top()].i);
            q.pop();
        }else{
            break;
        }
    }
}

bool solve(int n, int m,int g, vector<int> &c, vector<int> &v, vector<int> &u, vector<int> &w)
{
    for(int i = 1; i <= n; ++i)
    {
        ::c[i] = c[i - 1];
    }
    
    for(int i = 1; i <= m; ++i)
    {
        edge1[i] = {v[i - 1], u[i - 1], i, w[i - 1]};
    }
    srt(m);
    
    
    for(int i = 1; i <= n; ++i)
    {
        p[i] = i; sz[i] = 1;
        h += ::c[i];
    }
    e = 0;
    for(int i = 1; i <= m; ++i)
    {
        int x = get(edge[i].f);
        int y = get(edge[i].s);
        if (x == y) continue;
        
        unite(x, y);
        
        ed[edge[i].f].push_back({edge[i].f, edge[i].s, edge[i].i, edge[i].w});
        ed[edge[i].s].push_back({edge[i].s, edge[i].f, edge[i].i, edge[i].w});
        h -= edge[i].w;
        e++;
    }
    if (e != n - 1 || h < 0)
        return false;
    
    for (int i = 1; i <= n; ++i)
    {
        p[i] = i;
        sz[i] = 1;
        sum[i] = ::c[i];
    }
    cl = 0;
    dfs(1, 0);
    
    return true;
}
