mt19937 rnd(time(0));

int eval(vector<int> &vec, int p)
{
    vector<int> a = vec;
    int n = a.size();
    for (int i = 0; i<n; i++) a[i]%=p;
    sort(a.begin(), a.end());
    int maxx = 0;
    int counter = 1;
    for (int i = 1; i<n; i++)
    {
        if (a[i]==a[i-1]) counter++;
        else {maxx = max(maxx, counter); counter = 1;}
    }
    maxx = max(maxx, counter);
    return maxx;
}

int solve(int n, int g, vector<int> &a)
{
    if (n==1) return 1;
    sort(a.begin(), a.end());
    int answer = 0;
    answer = max(answer, eval(a, 2));
    vector<int> differences;
    
    for (int i = 0; i<50; i++)
    {
        int x = rnd()%n;
        int y = rnd()%n;
        while (y==x) y = rnd()%n;
        differences.push_back(abs(a[x]-a[y]));
    }
    
    set<int> divisors;
    for (auto dif: differences)
    {
        for (int i = 2; i<=sqrt(dif); i++) if (dif%i==0)
        {
            divisors.insert(i);
            while (dif%i==0) dif/=i;
        }
        if (dif!=1) divisors.insert(dif);
    }
    
    for (auto prime: divisors) answer = max(answer, eval(a, prime));
    return answer;
}
